#include <hitachi.mac>
; Finds alignment of data array of lifecells, so that most empty lines as
; possible are at bottom, empty cols at right

decwid  EQU 42h
arr     EQU 43h
width   EQU 45h
height  EQU 46h
bestcl  EQU 47h
bestrw  EQU 48h
bestcnt EQU 49h
count   EQU 4Ah

;Take down the addresses of arrays used
                              XGDX
                              LDD 2,X
                              STD width
                              LDX 0,X
                              STX arr
                              DEX
                              DEX
                              DEX
                              LDAB 0,X
                              STAB decwid

; Find longest gap of lines
                              CLRA
                              STAA bestrw
                              STAA bestcnt
                              STAA count
;First count the empty lines at bottom, to add to top gap
                              LDAB height
                              LDAA decwid
                              INCA
                              MUL
                              ADDD arr
                              XGDX
                              CLR decwid-1
                              LDAB height
btrwlp                        XGDX
                              SUBD decwid-1
                              XGDX
                              DEX
                              PSHX
                              BSR rowchk
                              PULX
                              BCS fndbot
                              INC count
                              DECB
                              BNE btrwlp
                              LDX %0
                              RTS

fndbot                        LDX arr
                              LDAB height
rwlp                          PSHX
                              BSR rowchk
                              PULX
                              BCS rowfull
                              LDAA count
                              INCA
                              STAA count
                              CMPA bestcnt
                              BCS nobstrw
                              STAA bestcnt
                              STAB bestrw
nobstrw                       BRA nxtrw
rowfull                       CLR count

nxtrw                         PSHB
                              LDAB decwid
                              ABX
                              INX
                              PULB
                              DECB
                              BNE rwlp


; Find longest gap of columns
;First count the empty cols at right, to add to left gap
                              CLRA
                              STAA bestcl
                              STAA bestcnt
                              STAA count
                              LDX arr
                              LDAB width
                              ABX
btcllp                        PSHX
                              PSHB
                              BSR colchk
                              PULB
                              PULX
                              BCS fndrght
                              INC count
                              DEX
                              DECB
                              BNE btcllp

fndrght                       LDX arr
                              LDAB width
cllp                          PSHX
                              PSHB
                              BSR colchk
                              PULB
                              PULX
                              BCS colfull
                              LDAA count
                              INCA
                              STAA count
                              CMPA bestcnt
                              BCS nobstcl
                              STAA bestcnt
                              STAB bestcl
nobstcl                       BRA nxtcl
colfull                       CLR count

nxtcl                         INX
                              DECB
                              BNE cllp

                              LDD width
                              SUBD bestcl
                              XGDX
                              RTS


rowchk                        LDAA width
rwchklp                       INX
                              TST 0,X
                              BNE cllfl
                              DECA
                              BNE rwchklp
                              CLC
                              RTS
cllfl                         SEC
                              RTS

colchk                        LDAA height
                              LDAB decwid
clchklp                       TST 1,X
                              BNE cllfl
                              ABX
                              INX
                              DECA
                              BNE clchklp
                              CLC
                              RTS
